program serientext_verteiler;  { (c) Michael Bloch, DF2VO, 28.12.1996 }

var f,g : text;
    i,n : integer;
    call, name, info, daten, s: string;

procedure makrowandlung(var zeile: string);
   const id = '%';  { Identifikationszeichen fr ein Makro }
         bell = chr(7);
         crlf = chr(13)+chr(10);
   var i: integer;
       ersatz, makro, zeileneu: string;
   begin
      zeileneu := '';
      while pos(id,zeile) > 0 do
      begin
         i := pos(id,zeile);
         makro := copy(zeile,i+1,1);
         if makro = '' then ersatz := id  { Ident direkt am Zeilenende }
                       else case upcase(makro[1]) of 'C' : ersatz := call;
                                                     'N' : ersatz := name;
                                                     'I' : ersatz := info;
                                                     'B' : ersatz := bell;
                                                     '_' : ersatz := crlf;
                                                     id  : ersatz := id
                            else ersatz := id+makro  { kein Makro gefunden }
                            end;
         zeileneu := zeileneu+copy(zeile,1,i-1)+ersatz;
         delete(zeile,1,i+1);
      end;
      zeile := zeileneu+zeile;
   end;

begin
   if paramcount <> 2 then
   begin
      writeln;
      writeln('SERITEXT.EXE  -  (c) by Michael Bloch, DF2VO, 28. Dezember 1996');
      writeln;
      writeln('Serienbriefartiges Verschicken einer Message aus  einer  "Serientextdatei"');
      writeln('an verschiedene User per Mailbox. Die Calls, Namen und ggf. kurze  indivi-');
      writeln('duelle Texte ("Infotext") werden aus einer separaten "Steuerdatei" gelesen');
      writeln('und an mit Makros gekennzeichnete Stellen in die Message eingefgt.');
      writeln;
      writeln('Die Steuerdatei enthlt pro zu versendender Message eine Zeile mit folgen-');
      writeln('dem Aufbau:');
      writeln('    <Call (ggf. mit MyBBS)>; <Name>; <individueller Infotext>');
      writeln;
      writeln('Name und Infotext knnen entfallen; Kommentarzeilen beginnen mit ";" !');
      writeln;
      writeln('Beispiel fr eine Steuerdatei:');
      writeln('    DF3VI; Patrick');
      writeln('    DF7CB; Christoph; %_Auch Gste aus anderen OV''n sind willkommen.');
      writeln('    DB6WY @ DB0PSC; Wolfi');
      writeln;
      writeln('Die Texte (Serien- und Infotext) knnen folgende Makros enthalten:');
      writeln('    %c = Rufzeichen (aus Steuerdatei),  %b = Bell (Klingel)');
      writeln('    %n = Name       (aus Steuerdatei),  %_ = Wagenrcklauf/Zeilenvorschub');
      writeln('    %i = Infotext   (aus Steuerdatei),  %% = Prozentzeichen');
      writeln;
      write('                                        Bitte RETURN drcken zum Fortfahren! ');
      readln;
      writeln('Beispiel fr eine Serientextdatei:');
      writeln('    s %c Einladung');
      writeln('    Hallo %n,');
      writeln('    hiermit lade ich Dich herzlich zum OV-Abend am kommenden Dienstag ein.%i');
      writeln('    vy 73 de Michael');
      writeln('    ***end');
      writeln;
      writeln('Erste und letzte Zeile (Send-Befehl und Dateiende) sind mailboxspezifisch.');
      writeln;
      writeln('Aufruf von SERITEXT von DOS aus: SERITEXT <serientextdatei> <steuerdatei>');
      writeln('Beispiel fr den Aufruf ...... : SERITEXT einladung.txt freunde.txt');
      writeln('Aufruf als RUN-Utility von GP');
      writeln('          ber ein ESC-Fernster: //seritext <serientextdatei> <steuerdatei>');
      writeln;
      writeln('!!! ausfhrliche Dokumentation siehe Anleitung SERITEXT.DOC !!!');
      writeln;
      exit;
   end;
   assign(f,paramstr(1));   { Datei mit dem zu versendenden Text }
   assign(g,paramstr(2));   { Datei mit der Liste der Calls und Namen }
   {$I-}
   reset(g);
   {$I+}
   if ioresult <> 0 then
   begin
      writeln;
      writeln('Die Datei "',paramstr(2),'" kann nicht geffnet werden.');
      writeln;
      exit;
   end;

   while not eof(g) do
      if seekeoln(g) then readln(g)  { Leerzeile }
         else
         begin
            call := ''; name := ''; info := '';
            readln(g,daten);  { Zeile aus Namendatei lesen }
            i := pos(';',daten);
            if i <> 1 then  { i=1 : Kommentarzeile mit ";" am Anfang berlesen }
            begin
               if i = 0 then call := daten  { kein Name angehngt }
                  else
                  begin
                     call := copy(daten,1,i-1);
                     delete(daten,1,i);
                     while pos(' ',daten) = 1 do delete(daten,1,1); { Leerzeichen berlesen }
                     i := pos(';',daten);
                     if i = 0 then name := daten { kein Infotext angehngt }
                        else
                        begin
                           name := copy(daten,1,i-1);
                           delete(daten,1,i);
                           while pos(' ',daten) = 1 do delete(daten,1,1); { Leerzeichen berlesen }
                           info := daten;
                           makrowandlung(info);
                        end;
                  end;

               {$I-}
               reset(f);
               {$I+}
               if ioresult <> 0 then
               begin
                  writeln;
                  writeln('Die Datei "',paramstr(1),'" kann nicht geffnet werden.');
                  writeln;
                  exit;
               end;
               while not eof(f) do
                  begin
                     readln(f, s);
                     makrowandlung(s);
                     writeln(s);
                  end;
            end;
         end;
   close(f);
   close(g);

end.
